import mitt from 'mitt';
import mapPromise from 'callbag-map-promise';
import filter from 'callbag-filter';

var isFn = function isFn(val) {
  return typeof val === 'function';
};

var index = (function () {
  for (var _len = arguments.length, epicses = new Array(_len), _key = 0; _key < _len; _key++) {
    epicses[_key] = arguments[_key];
  }

  return function (store) {
    var emitter = mitt();

    var actions = function actions(start, sink) {
      if (start !== 0) return;

      var handler = function handler(ev) {
        return sink(1, ev);
      };

      sink(0, function (t, d) {
        if (t === 2) emitter.off("action", handler);

        if (t === 1) {
          if (d && d.action) {
            store.dispatch(d.action);
          }
        }
      });
      emitter.on("action", handler);
    };

    epicses.forEach(function (epics) {
      if (typeof epics === "function") {
        epics(actions, store);
      }
    });
    return function (next) {
      return function (action) {
        emitter.emit("action", action);
        return next(action);
      };
    };
  };
});
var mapFromPromise = mapPromise;
var select = function select(_type) {
  return function (source) {
    return filter(function (_ref) {
      var type = _ref.type;
      return type === _type;
    })(source);
  };
};
var mapSuccessTo = function mapSuccessTo(actionType, fn) {
  return function (source) {
    var talkback;
    source(0, function (t, d) {
      if (t === 0) {
        talkback = d;
      }

      if (t === 1) {
        talkback(1, {
          action: {
            type: actionType,
            payload: isFn(fn) ? fn(d.payload) : d
          }
        });
      }
    });
    return function (t, sink) {
      if (t !== 0) return;
      source(0, function (t, d) {
        sink(t, d);
      });
    };
  };
};
var mapFailTo = function mapFailTo(actionType, fn) {
  return function (source) {
    var talkback;
    source(0, function (t, d) {
      if (t === 0) {
        talkback = d;
      }

      if (t === 2 && d !== undefined) {
        talkback(1, {
          action: {
            type: actionType,
            payload: isFn(fn) ? fn(d.payload) : d
          }
        });
      }
    });
    return function (t, sink) {
      if (t !== 0) return;
      source(0, function (t, d) {
        sink(t, d);
      });
    };
  };
};

export default index;
export { mapFromPromise, select, mapSuccessTo, mapFailTo };
